// Enemy
let enemy = {
    name: null,
    type: null,
    lvl: null,
    stats: {
        hp: null,
        hpMax: null,
        atk: 0,
        def: 0,
        atkSpd: 0,
        vamp: 0,
        critRate: 0,
        critDmg: 0
    },
    image: {
        name: null,
        type: null,
        size: null
    },
    rewards: {
        exp: null,
        gold: null,
        drop: null
    }
};

const generateRandomEnemy = (condition) => {
    // List of possible enemy names
    const enemyNames = [
        // 安保机器人
        'SD-110巡逻机', 'CL-7隐形单元', 'EMP-3干扰机', 'SR-9狙击机',
        // 外星寄生体
        '硅基寄生体', '暗物质兽', '冰晶异形',
        // 失控AI
        '数据幽灵', '光子构造体', '防御子程序', '战斗子程序',
        // 改造人
        '赛博剑士', '机械狂战士', '改造射手', '技术专家',
        // 纳米集群
        '纳米蛛群', '赤色纳米体', '翠绿纳米体',
        // 军用机器人
        '突击型MK-II', '剑刃型MK-V', '守卫型MK-X', '术士型AI', '掠夺者-7', '歼灭者-9', '战争机器',
        // Boss级单位
        'BOSS-血煞协议', 'BOSS-幽冥主机', '熔岩探测器', '三头守护者', '地狱犬系统', 'BOSS-不朽计划', 'BOSS-虚空核心', '巨蟹座防御平台', '光子泰坦', '龙骑兵指挥官', '堕落AI核心', '白羊座战斗系统', '蚁后控制中枢', '自律蛛形机甲', '嗜血狼型机',
        // 终极BOSS
        '蛛龙融合体', '死灵主脑', '等离子领主', '绝对零度', '巨兽级机甲', '血色主宰者', '深渊AI', '暗物质君主', '真龙级战舰'
    ];
    const enemyTypes = ['攻击型', '防御型', '平衡型', '敏捷型', '致命型'];
    let selectedEnemies = null;

    // Generate enemy type
    enemy.type = enemyTypes[Math.floor(Math.random() * enemyTypes.length)];

    // Calculate enemy level
    const maxLvl = dungeon.progress.floor * dungeon.settings.enemyLvlGap + (dungeon.settings.enemyBaseLvl - 1);
    const minLvl = maxLvl - (dungeon.settings.enemyLvlGap - 1);
    if (condition == "guardian") {
        enemy.lvl = minLvl;
    } else if (condition == "sboss") {
        enemy.lvl = maxLvl;
    } else {
        enemy.lvl = randomizeNum(minLvl, maxLvl);
    }

    // Generate proper enemy info
    switch (enemy.type) {
        case "攻击型":
            // Select name and apply stats for Offensive enemies
            if (condition == "guardian") {
                selectedEnemies = enemyNames.filter(name => [
                    'BOSS-血煞协议', 'BOSS-幽冥主机', '熔岩探测器', 'BOSS-不朽计划'
                ].includes(name));
            } else if (condition == "sboss") {
                selectedEnemies = enemyNames.filter(name => [
                    '巨兽级机甲', '真龙级战舰'
                ].includes(name));
            } else {
                selectedEnemies = enemyNames.filter(name => [
                    'EMP-3干扰机', 'SR-9狙击机',
                    '硅基寄生体', '暗物质兽', '冰晶异形',
                    '防御子程序',
                    '赛博剑士', '机械狂战士', '改造射手', '技术专家',
                    '赤色纳米体',
                    '突击型MK-II', '剑刃型MK-V', '术士型AI', '掠夺者-7', '歼灭者-9',
                ].includes(name));
            }
            enemy.name = selectedEnemies[Math.floor(Math.random() * selectedEnemies.length)];
            setEnemyStats(enemy.type, condition);
            break;
        case "防御型":
            // Select name and apply stats for Defensive enemies
            if (condition == "guardian") {
                selectedEnemies = enemyNames.filter(name => [
                    'BOSS-虚空核心', '巨蟹座防御平台', '光子泰坦'
                ].includes(name));
            } else if (condition == "sboss") {
                selectedEnemies = enemyNames.filter(name => [
                    '死灵主脑',
                ].includes(name));
            } else {
                selectedEnemies = enemyNames.filter(name => [
                    '光子构造体', '防御子程序', '战斗子程序',
                    '翠绿纳米体',
                    '守卫型MK-X', '战争机器'
                ].includes(name));
            }
            enemy.name = selectedEnemies[Math.floor(Math.random() * selectedEnemies.length)];
            setEnemyStats(enemy.type, condition);
            break;
        case "平衡型":
            // Select name and apply stats for Balanced enemies
            if (condition == "guardian") {
                selectedEnemies = enemyNames.filter(name => [
                    '龙骑兵指挥官', '堕落AI核心', '白羊座战斗系统'
                ].includes(name));
            } else if (condition == "sboss") {
                selectedEnemies = enemyNames.filter(name => [
                    '等离子领主', '绝对零度', '暗物质君主'
                ].includes(name));
            } else {
                selectedEnemies = enemyNames.filter(name => [
                    'SD-110巡逻机', 'CL-7隐形单元',
                    '数据幽灵', '光子构造体',
                    '纳米蛛群', '翠绿纳米体',
                    '守卫型MK-X', '战争机器'
                ].includes(name));
            }
            enemy.name = selectedEnemies[Math.floor(Math.random() * selectedEnemies.length)];
            setEnemyStats(enemy.type, condition);
            break;
        case "敏捷型":
            // Select name and apply stats for Quick enemies
            if (condition == "guardian") {
                selectedEnemies = enemyNames.filter(name => [
                    '蚁后控制中枢', '自律蛛形机甲'
                ].includes(name));
            } else if (condition == "sboss") {
                selectedEnemies = enemyNames.filter(name => [
                    '深渊AI', '蛛龙融合体'
                ].includes(name));
            } else {
                selectedEnemies = enemyNames.filter(name => [
                    'CL-7隐形单元', 'EMP-3干扰机', 'SR-9狙击机',
                    '硅基寄生体', '暗物质兽', '冰晶异形',
                    '赛博剑士',
                    '纳米蛛群', '赤色纳米体', '翠绿纳米体',
                    '突击型MK-II', '剑刃型MK-V', '掠夺者-7'
                ].includes(name));
            }
            enemy.name = selectedEnemies[Math.floor(Math.random() * selectedEnemies.length)];
            setEnemyStats(enemy.type, condition);
            break;
        case "致命型":
            // Select name and apply stats for Lethal enemies
            if (condition == "guardian") {
                selectedEnemies = enemyNames.filter(name => [
                    '嗜血狼型机', '地狱犬系统', '三头守护者'
                ].includes(name));
            } else if (condition == "sboss") {
                selectedEnemies = enemyNames.filter(name => [
                    '血色主宰者'
                ].includes(name));
            } else {
                selectedEnemies = enemyNames.filter(name => [
                    'EMP-3干扰机',
                    '硅基寄生体', '暗物质兽', '冰晶异形',
                    '赛博剑士', '机械狂战士',
                    '赤色纳米体',
                    '突击型MK-II', '剑刃型MK-V'
                ].includes(name));
            }
            enemy.name = selectedEnemies[Math.floor(Math.random() * selectedEnemies.length)];
            setEnemyStats(enemy.type, condition);
            break;
    }
    if (condition == "chest") {
        enemy.name = "能量守护AI";
    } else if (condition == "door") {
        enemy.name = "跃迁点守卫";
    }
    setEnemyImg();
}

// Set a randomly generated stat for the enemy
const setEnemyStats = (type, condition) => {
    if (type == "攻击型") {
        enemy.stats = {
            hp: 0,
            hpMax: randomizeNum(300, 370),
            atk: randomizeNum(70, 100),
            def: randomizeNum(20, 50),
            atkSpd: randomizeDecimal(0.2, 0.4),
            vamp: 0,
            critRate: randomizeDecimal(1, 4),
            critDmg: randomizeDecimal(6.5, 7.5)
        };
    } else if (type == "防御型") {
        enemy.stats = {
            hp: 0,
            hpMax: randomizeNum(400, 500),
            atk: randomizeNum(40, 70),
            def: randomizeNum(40, 70),
            atkSpd: randomizeDecimal(0.1, 0.3),
            vamp: 0,
            critRate: 0,
            critDmg: 0
        };
    } else if (type == "平衡型") {
        enemy.stats = {
            hp: 0,
            hpMax: randomizeNum(320, 420),
            atk: randomizeNum(50, 80),
            def: randomizeNum(30, 60),
            atkSpd: randomizeDecimal(0.15, 0.35),
            vamp: 0,
            critRate: randomizeDecimal(0.5, 1.5),
            critDmg: randomizeDecimal(1, 3)
        };
    } else if (type == "敏捷型") {
        enemy.stats = {
            hp: 0,
            hpMax: randomizeNum(300, 370),
            atk: randomizeNum(50, 80),
            def: randomizeNum(30, 60),
            atkSpd: randomizeDecimal(0.35, 0.45),
            vamp: 0,
            critRate: randomizeDecimal(1, 4),
            critDmg: randomizeDecimal(3, 6)
        };
    } else if (type == "致命型") {
        enemy.stats = {
            hp: 0,
            hpMax: randomizeNum(300, 370),
            atk: randomizeNum(70, 100),
            def: randomizeNum(20, 50),
            atkSpd: randomizeDecimal(0.15, 0.35),
            vamp: 0,
            critRate: randomizeDecimal(4, 8),
            critDmg: randomizeDecimal(6, 9)
        };
    }

    if (dungeon.enemyMultipliers == undefined) {
        dungeon.enemyMultipliers = {
            hp: 1,
            atk: 1,
            def: 1,
            atkSpd: 1,
            vamp: 1,
            critRate: 1,
            critDmg: 1
        }
    }

    // Apply stat scaling for enemies each level
    for (const stat in enemy.stats) {
        if (["hpMax", "atk", "def"].includes(stat)) {
            enemy.stats[stat] += Math.round(enemy.stats[stat] * ((dungeon.settings.enemyScaling - 1) * enemy.lvl));
        } else if (["atkSpd"].includes(stat)) {
            enemy.stats[stat] = 0.4;
            enemy.stats[stat] += enemy.stats[stat] * (((dungeon.settings.enemyScaling - 1) / 4) * enemy.lvl);
        } else if (["critRate"].includes(stat)) {
            enemy.stats[stat] += enemy.stats[stat] * (((dungeon.settings.enemyScaling - 1) / 4) * enemy.lvl);
        } else if (["critDmg"].includes(stat)) {
            enemy.stats[stat] = 50;
            enemy.stats[stat] += enemy.stats[stat] * (((dungeon.settings.enemyScaling - 1) / 4) * enemy.lvl);
        }
    }

    // Stat multiplier for floor guardians
    if (condition == "guardian") {
        enemy.stats.hpMax = enemy.stats.hpMax * 1.5;
        enemy.stats.atk = enemy.stats.atk * 1.3;
        enemy.stats.def = enemy.stats.def * 1.3;
        enemy.stats.critRate = enemy.stats.critRate * 1.1;
        enemy.stats.critDmg = enemy.stats.critDmg * 1.2;
    }

    // Stat multiplier for monarchs
    if (condition == "sboss") {
        enemy.stats.hpMax = enemy.stats.hpMax * 6;
        enemy.stats.atk = enemy.stats.atk * 2;
        enemy.stats.def = enemy.stats.def * 2;
        enemy.stats.critRate = enemy.stats.critRate * 1.1;
        enemy.stats.critDmg = enemy.stats.critDmg * 1.3;
    }

    // Apply stat multipliers for every stat
    let floorMultiplier = (dungeon.progress.floor / 3);
    if (floorMultiplier < 1) {
        floorMultiplier = 1;
    }
    enemy.stats.hpMax = Math.round((enemy.stats.hpMax * floorMultiplier) * dungeon.enemyMultipliers.hp);
    enemy.stats.atk = Math.round(enemy.stats.atk * dungeon.enemyMultipliers.atk);
    enemy.stats.def = Math.round(enemy.stats.def * dungeon.enemyMultipliers.def);
    enemy.stats.atkSpd = enemy.stats.atkSpd * dungeon.enemyMultipliers.atkSpd;
    enemy.stats.vamp = enemy.stats.vamp * dungeon.enemyMultipliers.vamp;
    enemy.stats.critRate = enemy.stats.critRate * dungeon.enemyMultipliers.critRate;
    enemy.stats.critDmg = enemy.stats.critDmg * dungeon.enemyMultipliers.critDmg;

    // Calculate exp and gold that the monster gives
    const expYield = [];

    for (const stat in enemy.stats) {
        let statExp = 0;
        const statValue = safeNumber(enemy.stats[stat], 0);
        
        if (["hpMax", "atk", "def"].includes(stat)) {
            statExp = statValue + statValue * 0.5;
        } else if (["atkSpd", "critRate", "critDmg"].includes(stat)) {
            statExp = statValue + statValue * 2;
        } else if (["vamp", "hp"].includes(stat)) {
            statExp = statValue + statValue * 1;
        }
        
        // 确保计算结果安全
        statExp = safeNumber(statExp, 1);
        expYield.push(statExp);
    }

    let expCalculation = safeNumber((expYield.reduce((acc, cur) => acc + cur, 0)) / 20, 10);
    enemy.rewards.exp = Math.round(safeNumber(expCalculation + expCalculation * (enemy.lvl * 0.1), expCalculation));
    if (enemy.rewards.exp > 1000000) {
        enemy.rewards.exp = safeNumber(1000000 * randomizeDecimal(0.9, 1.1), 900000);
    }
    
    // 确保金币计算安全，最低10金币
    const goldBase = safeNumber(enemy.rewards.exp * randomizeDecimal(0.9, 1.1), enemy.rewards.exp || 10);
    enemy.rewards.gold = Math.max(Math.round(goldBase * 1.5), 10);
    enemy.rewards.drop = randomizeNum(1, 3);
    if (enemy.rewards.drop == 1) {
        enemy.rewards.drop = true;
    } else {
        enemy.rewards.drop = false;
    }

    enemy.stats.hp = enemy.stats.hpMax;
    enemy.stats.hpPercent = 100;

    // Caps attack speed to 2.5
    if (enemy.stats.atkSpd > 2.5) {
        enemy.stats.atkSpd = 2.5;
    }
}

const setEnemyImg = () => {
    // 不再使用图片，所有敌人都用文字显示
    enemy.image.type = null;
    enemy.image.name = null;
    enemy.image.size = null;
}

const enemyLoadStats = () => {
    // Shows proper percentage for respective stats
    let rx = /\.0+$|(\.[0-9]*[1-9])0+$/;
    if (enemy.stats.hp > enemy.stats.hpMax) {
        enemy.stats.hp = enemy.stats.hpMax;
    }
    enemy.stats.hpPercent = ((enemy.stats.hp / enemy.stats.hpMax) * 100).toFixed(2).replace(rx, "$1");

    const enemyHpElement = document.querySelector('#enemy-hp-battle');
    const enemyHpDamageElement = document.querySelector('#enemy-hp-dmg');
    enemyHpElement.innerHTML = `&nbsp${nFormatter(enemy.stats.hp)}/${nFormatter(enemy.stats.hpMax)}<br>(${enemy.stats.hpPercent}%)`;
    enemyHpElement.style.width = `${enemy.stats.hpPercent}%`;
    enemyHpDamageElement.style.width = `${enemy.stats.hpPercent}%`;
}