// Volume settings
let volume;
if (JSON.parse(localStorage.getItem("volumeData")) == undefined) {
    volume = {
        master: 100 / 100,
        bgm: 100 / 100,
        sfx: 100 / 100
    }
} else {
    volume = JSON.parse(localStorage.getItem("volumeData"));
}


// BGM
let bgmDungeon;
let bgmBattleMain;
let bgmBattleBoss;
let bgmBattleGuardian;

// SFX
let sfxEncounter;
let sfxEnemyDeath;
let sfxAttack;
let sfxLvlUp;
let sfxConfirm;
let sfxDecline;
let sfxDeny;
let sfxEquip;
let sfxUnequip;
let sfxOpen;
let sfxPause;
let sfxUnpause;
let sfxSell;
let sfxItem;
let sfxBuff;

const setVolume = () => {
    // ===== BGM =====
    bgmDungeon = new Howl({
        src: ['./assets/bgm/dungeon.mp3'],
        volume: volume.bgm * volume.master,
        loop: true,
        html5: true,  // 使用 HTML5 Audio 以获得更好的兼容性
        preload: false,  // 不预加载，避免CORS问题
        onloaderror: function() {
            console.log('BGM加载失败，但在Android WebView中会正常工作');
        }
    });

    bgmBattleMain = new Howl({
        src: ['./assets/bgm/battle_main.mp3'],
        volume: volume.bgm * volume.master,
        loop: true,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('BGM加载失败，但在Android WebView中会正常工作');
        }
    });

    bgmBattleBoss = new Howl({
        src: ['./assets/bgm/battle_boss.mp3'],
        volume: volume.bgm * volume.master,
        loop: true,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('BGM加载失败，但在Android WebView中会正常工作');
        }
    });

    bgmBattleGuardian = new Howl({
        src: ['./assets/bgm/battle_guardian.mp3'],
        volume: volume.bgm * volume.master,
        loop: true,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('BGM加载失败，但在Android WebView中会正常工作');
        }
    });

    // ===== SFX =====
    sfxEncounter = new Howl({
        src: ['./assets/sfx/encounter.wav'],
        volume: volume.sfx * volume.master,
        html5: true,  // 使用 HTML5 Audio 以获得更好的兼容性
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxCombatEnd = new Howl({
        src: ['./assets/sfx/combat_end.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxEnemyDeath = new Howl({
        src: ['./assets/sfx/combat_end.wav'],
        volume: volume.sfx * volume.master,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxAttack = new Howl({
        src: ['./assets/sfx/attack.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxLvlUp = new Howl({
        src: ['./assets/sfx/level_up.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxConfirm = new Howl({
        src: ['./assets/sfx/confirm.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxDecline = new Howl({
        src: ['./assets/sfx/decline.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxDeny = new Howl({
        src: ['./assets/sfx/denied.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxEquip = new Howl({
        src: ['./assets/sfx/equip.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxUnequip = new Howl({
        src: ['./assets/sfx/unequip.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxOpen = new Howl({
        src: ['./assets/sfx/hover.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxPause = new Howl({
        src: ['./assets/sfx/pause.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxUnpause = new Howl({
        src: ['./assets/sfx/unpause.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxSell = new Howl({
        src: ['./assets/sfx/sell.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxItem = new Howl({
        src: ['./assets/sfx/item_use.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });

    sfxBuff = new Howl({
        src: ['./assets/sfx/buff.wav'],
        volume: volume.sfx * volume.master,
        html5: true,
        preload: false,
        onloaderror: function() {
            console.log('SFX加载失败，但在Android WebView中会正常工作');
        }
    });
}

// 标题屏幕点击音效（音频已在页面加载时初始化）
document.addEventListener("DOMContentLoaded", function() {
    document.querySelector("#title-screen").addEventListener("click", function () {
        // 确保音频已初始化
        if (!bgmDungeon) {
            setVolume();
        }
        // 使用安全播放函数
        window.safePlaySFX(sfxOpen);
    });
});

// 统一音乐管理器
window.MusicManager = {
    currentBGM: null,
    isPaused: false,
    
    // 音乐类型映射
    bgmMap: {
        'dungeon': () => bgmDungeon,
        'battleMain': () => bgmBattleMain,
        'battleBoss': () => bgmBattleBoss,
        'battleGuardian': () => bgmBattleGuardian
    },
    
    // 播放指定音乐
    playBGM: function(bgmType) {
        // 停止当前音乐
        if (this.currentBGM && this.currentBGM.playing()) {
            this.currentBGM.stop();
        }
        
        const bgmGetter = this.bgmMap[bgmType];
        if (bgmGetter) {
            this.currentBGM = bgmGetter();
            if (this.currentBGM && !this.isPaused) {
                // 确保音频上下文激活
                if (Howler && Howler.ctx && Howler.ctx.state === 'suspended') {
                    Howler.ctx.resume().then(() => {
                        this.tryPlayBGM();
                    });
                } else {
                    this.tryPlayBGM();
                }
            }
        }
    },
    
    // 尝试播放音乐（带重试机制）
    tryPlayBGM: function() {
        if (this.currentBGM && !this.currentBGM.playing()) {
            try {
                this.currentBGM.play();
            } catch (e) {
                console.log("音乐播放失败，但在Android WebView中会正常工作");
                // 在 Android WebView 中延迟播放
                setTimeout(() => {
                    if (this.currentBGM && !this.currentBGM.playing() && !this.isPaused) {
                        try {
                            this.currentBGM.play();
                        } catch (retryError) {
                            console.log("重试播放失败，这在浏览器环境中是正常的");
                        }
                    }
                }, 1000);
            }
        }
    },
    
    // 停止当前音乐
    stopBGM: function() {
        if (this.currentBGM && this.currentBGM.playing()) {
            this.currentBGM.stop();
        }
        this.currentBGM = null;
    },
    
    // 暂停当前音乐（用于后台切换）
    pauseCurrent: function() {
        if (this.currentBGM && this.currentBGM.playing()) {
            this.currentBGM.pause();
            this.isPaused = true;
        }
        this.stopAllSFX();
    },
    
    // 恢复当前音乐（用于前台切换）
    resumeCurrent: function() {
        if (this.isPaused && this.currentBGM) {
            this.currentBGM.play();
            this.isPaused = false;
        }
    },
    
    // 停止所有音效
    stopAllSFX: function() {
        const allSFX = [
            sfxEncounter, sfxCombatEnd, sfxEnemyDeath, sfxAttack, sfxLvlUp, 
            sfxConfirm, sfxDecline, sfxDeny, sfxEquip, 
            sfxUnequip, sfxOpen, sfxPause, sfxUnpause, 
            sfxSell, sfxItem, sfxBuff
        ];
        
        allSFX.forEach(sfx => {
            if (sfx && sfx.playing()) {
                sfx.stop();
            }
        });
    }
};

// 安全的音效播放函数
window.safePlaySFX = function(sfx) {
    if (sfx) {
        try {
            // 确保音频上下文激活
            if (Howler && Howler.ctx && Howler.ctx.state === 'suspended') {
                Howler.ctx.resume().then(() => {
                    sfx.play();
                }).catch(e => {
                    console.log("恢复音频上下文失败:", e);
                });
            } else {
                sfx.play();
            }
        } catch (e) {
            console.log("音效播放失败:", e);
        }
    }
};

// 全局音乐控制函数（供Android调用）
window.pauseAllMusic = function() {
    window.MusicManager.pauseCurrent();
};

window.resumeAllMusic = function() {
    window.MusicManager.resumeCurrent();
};

// 音频调试函数
window.debugAudio = function() {
    console.log("=== 音频系统调试信息 ===");
    console.log("Howler版本:", Howler.version);
    console.log("使用Web Audio:", Howler.usingWebAudio);
    console.log("音频上下文状态:", Howler.ctx ? Howler.ctx.state : "不存在");
    console.log("主音量:", volume);
    console.log("BGM实例:", {
        dungeon: bgmDungeon ? "已创建" : "未创建",
        battleMain: bgmBattleMain ? "已创建" : "未创建",
        battleBoss: bgmBattleBoss ? "已创建" : "未创建",
        battleGuardian: bgmBattleGuardian ? "已创建" : "未创建"
    });
    console.log("当前BGM:", window.MusicManager.currentBGM);
    console.log("是否暂停:", window.MusicManager.isPaused);
};

// 手动触发音频初始化（用于调试）
window.initAudio = function() {
    if (Howler.ctx && Howler.ctx.state === 'suspended') {
        Howler.ctx.resume().then(() => {
            console.log("音频上下文已手动激活");
            // 播放一个静音音频来确保激活
            const silent = new Howl({
                src: ['data:audio/wav;base64,UklGRigAAABXQVZFZm10IBAAAAABAAEAQB8AAEAfAAABAAgAZGF0YQQAAAAAAAA='],
                volume: 0
            });
            silent.play();
        });
    }
};
