// ========== 量子商店科幻SVG图标系统 ==========

const shopIcons = {
    // 处理器超频芯片
    "cpu-overclock": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="cpuGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#00ffff;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#0099ff;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#6600ff;stop-opacity:1" />
            </linearGradient>
            <radialGradient id="cpuCore" cx="50%" cy="50%">
                <stop offset="0%" style="stop-color:#ffffff;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#00ffff;stop-opacity:0.8" />
                <stop offset="100%" style="stop-color:#0066ff;stop-opacity:0.4" />
            </radialGradient>
            <filter id="cpuGlow">
                <feGaussianBlur stdDeviation="3" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <!-- CPU基板 -->
        <rect x="20" y="20" width="60" height="60" rx="8" fill="#0a0a1a" stroke="url(#cpuGrad)" stroke-width="3"/>
        <!-- 处理器核心 -->
        <rect x="30" y="30" width="40" height="40" rx="4" fill="url(#cpuCore)" stroke="#00ffff" stroke-width="2"/>
        <!-- 电路纹路 -->
        <path d="M 35,35 L 45,35 L 45,45 L 55,45 L 55,55 L 65,55 M 35,45 L 40,45 M 35,55 L 40,55 M 50,35 L 55,35 M 60,35 L 65,35 M 60,45 L 65,45" 
              stroke="#00ffff" stroke-width="1.5" fill="none" opacity="0.8"/>
        <!-- 引脚 -->
        <g stroke="#00ccff" stroke-width="2" opacity="0.9">
            <path d="M 10,25 L 20,25 M 10,35 L 20,35 M 10,45 L 20,45 M 10,55 L 20,55 M 10,65 L 20,65 M 10,75 L 20,75"/>
            <path d="M 80,25 L 90,25 M 80,35 L 90,35 M 80,45 L 90,45 M 80,55 L 90,55 M 80,65 L 90,65 M 80,75 L 90,75"/>
            <path d="M 25,10 L 25,20 M 35,10 L 35,20 M 45,10 L 45,20 M 55,10 L 55,20 M 65,10 L 65,20 M 75,10 L 75,20"/>
            <path d="M 25,80 L 25,90 M 35,80 L 35,90 M 45,80 L 45,90 M 55,80 L 55,90 M 65,80 L 65,90 M 75,80 L 75,90"/>
        </g>
        <!-- 超频指示器 -->
        <circle cx="50" cy="50" r="8" fill="none" stroke="#ffffff" stroke-width="2" opacity="0.6"/>
        <polygon points="50,42 54,50 50,58 46,50" fill="#ffffff" filter="url(#cpuGlow)"/>
        <!-- 能量脉冲动画 -->
        <circle cx="50" cy="50" r="15" fill="none" stroke="#00ffff" stroke-width="1" opacity="0.5">
            <animate attributeName="r" values="15;25;15" dur="2s" repeatCount="indefinite"/>
            <animate attributeName="opacity" values="0.5;0.1;0.5" dur="2s" repeatCount="indefinite"/>
        </circle>
    </svg>`,
    
    // 武器系统过载
    "weapon-overload": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="weaponGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#ff3300;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#ff6600;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#ffaa00;stop-opacity:1" />
            </linearGradient>
            <radialGradient id="muzzleFlash" cx="50%" cy="50%">
                <stop offset="0%" style="stop-color:#ffffff;stop-opacity:1" />
                <stop offset="30%" style="stop-color:#ffff00;stop-opacity:0.9" />
                <stop offset="70%" style="stop-color:#ff6600;stop-opacity:0.6" />
                <stop offset="100%" style="stop-color:#ff0000;stop-opacity:0.2" />
            </radialGradient>
            <filter id="weaponGlow">
                <feGaussianBlur stdDeviation="3" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <!-- 武器主体 -->
        <rect x="15" y="42" width="55" height="16" rx="8" fill="#1a1a2a" stroke="#444" stroke-width="2"/>
        <!-- 能量导管 -->
        <rect x="20" y="46" width="45" height="8" rx="4" fill="url(#weaponGrad)" opacity="0.8"/>
        <!-- 散热片 -->
        <g stroke="#666" stroke-width="1.5" opacity="0.7">
            <path d="M 25,38 L 25,42 M 30,38 L 30,42 M 35,38 L 35,42 M 40,38 L 40,42 M 45,38 L 45,42"/>
            <path d="M 25,58 L 25,62 M 30,58 L 30,62 M 35,58 L 35,62 M 40,58 L 40,62 M 45,58 L 45,62"/>
        </g>
        <!-- 瞄准镜 -->
        <rect x="50" y="40" width="15" height="6" rx="3" fill="#333" stroke="#666" stroke-width="1"/>
        <circle cx="57" cy="43" r="2" fill="#0066ff" opacity="0.8"/>
        <!-- 枪口火焰 -->
        <ellipse cx="78" cy="50" rx="18" ry="12" fill="url(#muzzleFlash)" opacity="0.8" filter="url(#weaponGlow)"/>
        <!-- 火花效果 -->
        <g opacity="0.9">
            <circle cx="85" cy="45" r="2" fill="#ffff00">
                <animate attributeName="opacity" values="1;0;1" dur="0.5s" repeatCount="indefinite"/>
            </circle>
            <circle cx="90" cy="50" r="1.5" fill="#ff6600">
                <animate attributeName="opacity" values="0;1;0" dur="0.7s" repeatCount="indefinite"/>
            </circle>
            <circle cx="87" cy="55" r="1" fill="#ffffff">
                <animate attributeName="opacity" values="1;0;1" dur="0.3s" repeatCount="indefinite"/>
            </circle>
        </g>
        <!-- 能量脉冲 -->
        <rect x="20" y="49" width="45" height="2" fill="#ffffff" opacity="0.6">
            <animate attributeName="opacity" values="0.6;1;0.6" dur="1s" repeatCount="indefinite"/>
        </rect>
    </svg>`,
    
    // 护盾矩阵增幅
    "shield-boost": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="shieldGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#00ddff;stop-opacity:0.9" />
                <stop offset="50%" style="stop-color:#0099ff;stop-opacity:0.7" />
                <stop offset="100%" style="stop-color:#0044aa;stop-opacity:0.5" />
            </linearGradient>
            <radialGradient id="shieldCore" cx="50%" cy="45%">
                <stop offset="0%" style="stop-color:#ffffff;stop-opacity:0.8" />
                <stop offset="50%" style="stop-color:#00ccff;stop-opacity:0.6" />
                <stop offset="100%" style="stop-color:#0066cc;stop-opacity:0.2" />
            </radialGradient>
            <pattern id="hexGrid" x="0" y="0" width="12" height="12" patternUnits="userSpaceOnUse">
                <polygon points="6,1 11,4 11,8 6,11 1,8 1,4" 
                         fill="none" stroke="#00ccff" stroke-width="0.8" opacity="0.4"/>
            </pattern>
            <filter id="shieldGlow">
                <feGaussianBlur stdDeviation="2" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <!-- 主护盾 -->
        <path d="M 50,12 L 78,22 L 78,52 C 78,78 50,88 50,88 C 50,88 22,78 22,52 L 22,22 Z" 
              fill="url(#shieldGrad)" stroke="#00ccff" stroke-width="3" filter="url(#shieldGlow)"/>
        <!-- 六边形网格 -->
        <path d="M 50,18 L 72,26 L 72,50 C 72,72 50,82 50,82 C 50,82 28,72 28,50 L 28,26 Z" 
              fill="url(#hexGrid)" opacity="0.6"/>
        <!-- 能量核心 -->
        <ellipse cx="50" cy="45" rx="15" ry="12" fill="url(#shieldCore)" opacity="0.8"/>
        <!-- 增幅器标识 -->
        <g stroke="#ffffff" stroke-width="2.5" fill="none" stroke-linecap="round">
            <path d="M 42,40 L 50,32 L 58,40"/>
            <path d="M 50,32 L 50,50"/>
            <path d="M 45,45 L 55,45"/>
        </g>
        <!-- 能量波纹 -->
        <circle cx="50" cy="45" r="20" fill="none" stroke="#00ccff" stroke-width="1.5" opacity="0.4">
            <animate attributeName="r" values="20;35;20" dur="3s" repeatCount="indefinite"/>
            <animate attributeName="opacity" values="0.4;0.1;0.4" dur="3s" repeatCount="indefinite"/>
        </circle>
        <circle cx="50" cy="45" r="25" fill="none" stroke="#00aaff" stroke-width="1" opacity="0.3">
            <animate attributeName="r" values="25;40;25" dur="4s" repeatCount="indefinite"/>
            <animate attributeName="opacity" values="0.3;0.05;0.3" dur="4s" repeatCount="indefinite"/>
        </circle>
    </svg>`,
    
    // 精准瞄准模块
    "crit-module": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <radialGradient id="targetGrad" cx="50%" cy="50%">
                <stop offset="0%" style="stop-color:#ffffff;stop-opacity:1" />
                <stop offset="30%" style="stop-color:#ff0066;stop-opacity:0.8" />
                <stop offset="70%" style="stop-color:#cc0044;stop-opacity:0.4" />
                <stop offset="100%" style="stop-color:#880022;stop-opacity:0.1" />
            </radialGradient>
            <linearGradient id="scopeGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#ff0066;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#ff3388;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#ff6699;stop-opacity:1" />
            </linearGradient>
            <filter id="targetGlow">
                <feGaussianBlur stdDeviation="2" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <!-- 瞄准镜外环 -->
        <circle cx="50" cy="50" r="42" fill="none" stroke="#333" stroke-width="6"/>
        <circle cx="50" cy="50" r="39" fill="none" stroke="url(#scopeGrad)" stroke-width="2"/>
        <!-- 瞄准圈 -->
        <circle cx="50" cy="50" r="32" fill="none" stroke="#ff0066" stroke-width="2" opacity="0.8"/>
        <circle cx="50" cy="50" r="24" fill="none" stroke="#ff3388" stroke-width="1.5" opacity="0.7"/>
        <circle cx="50" cy="50" r="16" fill="none" stroke="#ff6699" stroke-width="1" opacity="0.6"/>
        <!-- 中心目标 -->
        <circle cx="50" cy="50" r="12" fill="url(#targetGrad)" filter="url(#targetGlow)"/>
        <circle cx="50" cy="50" r="4" fill="#ff0066"/>
        <circle cx="50" cy="50" r="1.5" fill="#ffffff"/>
        <!-- 十字准星 -->
        <g stroke="#ff0066" stroke-width="3" stroke-linecap="round" opacity="0.9">
            <path d="M 50,8 L 50,25"/>
            <path d="M 50,75 L 50,92"/>
            <path d="M 8,50 L 25,50"/>
            <path d="M 75,50 L 92,50"/>
        </g>
        <!-- 角度标记 -->
        <g stroke="#ff3388" stroke-width="2" opacity="0.7">
            <path d="M 18,18 L 26,26"/>
            <path d="M 82,18 L 74,26"/>
            <path d="M 18,82 L 26,74"/>
            <path d="M 82,82 L 74,74"/>
        </g>
        <!-- 扫描线 -->
        <line x1="50" y1="50" x2="75" y2="25" stroke="#ffffff" stroke-width="1.5" opacity="0.8">
            <animateTransform attributeName="transform" type="rotate" 
                            values="0 50 50;360 50 50" dur="4s" repeatCount="indefinite"/>
        </line>
        <!-- 激光点 -->
        <circle cx="50" cy="50" r="8" fill="none" stroke="#ff0066" stroke-width="1" opacity="0.5">
            <animate attributeName="r" values="8;12;8" dur="2s" repeatCount="indefinite"/>
            <animate attributeName="opacity" values="0.5;0.9;0.5" dur="2s" repeatCount="indefinite"/>
        </circle>
    </svg>`,
    
    // 伤害放大器
    "damage-amplifier": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="damageGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#ff0099;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#ff0066;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#cc0033;stop-opacity:1" />
            </linearGradient>
            <radialGradient id="explosionCore" cx="50%" cy="50%">
                <stop offset="0%" style="stop-color:#ffffff;stop-opacity:1" />
                <stop offset="30%" style="stop-color:#ffff00;stop-opacity:0.9" />
                <stop offset="70%" style="stop-color:#ff6600;stop-opacity:0.6" />
                <stop offset="100%" style="stop-color:#ff0066;stop-opacity:0.2" />
            </radialGradient>
            <filter id="damageGlow">
                <feGaussianBlur stdDeviation="3" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <!-- 爆炸星形外框 -->
        <polygon points="50,8 62,35 90,35 70,52 82,80 50,65 18,80 30,52 10,35 38,35" 
                 fill="#1a0a1a" stroke="url(#damageGrad)" stroke-width="3" filter="url(#damageGlow)"/>
        <!-- 内部能量 -->
        <polygon points="50,15 58,38 80,38 65,50 72,73 50,62 28,73 35,50 20,38 42,38" 
                 fill="url(#explosionCore)" opacity="0.8"/>
        <!-- 中心倍数显示 -->
        <circle cx="50" cy="50" r="18" fill="#000000" stroke="#ff0066" stroke-width="2" opacity="0.9"/>
        <text x="50" y="48" text-anchor="middle" fill="#ffffff" font-size="12" font-weight="bold">DMG</text>
        <text x="50" y="60" text-anchor="middle" fill="#ff0066" font-size="16" font-weight="bold">×2</text>
        <!-- 能量爆发效果 -->
        <g opacity="0.7">
            <circle cx="50" cy="50" r="25" fill="none" stroke="#ff0066" stroke-width="2" opacity="0.5">
                <animate attributeName="r" values="25;35;25" dur="1.5s" repeatCount="indefinite"/>
                <animate attributeName="opacity" values="0.5;0.1;0.5" dur="1.5s" repeatCount="indefinite"/>
            </circle>
            <circle cx="50" cy="50" r="30" fill="none" stroke="#ff3388" stroke-width="1" opacity="0.3">
                <animate attributeName="r" values="30;45;30" dur="2s" repeatCount="indefinite"/>
                <animate attributeName="opacity" values="0.3;0.05;0.3" dur="2s" repeatCount="indefinite"/>
            </circle>
        </g>
    </svg>`,
    
    // 纳米修复协议（吸血）
    "life-steal": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="nanoGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#00ff88;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#00cc66;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#009944;stop-opacity:1" />
            </linearGradient>
            <radialGradient id="healCore" cx="50%" cy="50%">
                <stop offset="0%" style="stop-color:#ffffff;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#88ff88;stop-opacity:0.8" />
                <stop offset="100%" style="stop-color:#00aa44;stop-opacity:0.3" />
            </radialGradient>
            <filter id="nanoGlow">
                <feGaussianBlur stdDeviation="2" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <!-- 纳米修复单元外壳 -->
        <circle cx="50" cy="50" r="38" fill="#0a1a0a" stroke="url(#nanoGrad)" stroke-width="3" filter="url(#nanoGlow)"/>
        <!-- 修复核心 -->
        <circle cx="50" cy="50" r="28" fill="url(#healCore)" opacity="0.7"/>
        <!-- DNA螺旋结构 -->
        <g stroke="#00ff88" stroke-width="2.5" fill="none" opacity="0.9">
            <path d="M 30,35 Q 40,25 50,35 Q 60,45 70,35">
                <animate attributeName="d" values="M 30,35 Q 40,25 50,35 Q 60,45 70,35;M 30,35 Q 40,45 50,35 Q 60,25 70,35;M 30,35 Q 40,25 50,35 Q 60,45 70,35" dur="3s" repeatCount="indefinite"/>
            </path>
            <path d="M 30,50 Q 40,40 50,50 Q 60,60 70,50">
                <animate attributeName="d" values="M 30,50 Q 40,40 50,50 Q 60,60 70,50;M 30,50 Q 40,60 50,50 Q 60,40 70,50;M 30,50 Q 40,40 50,50 Q 60,60 70,50" dur="3s" repeatCount="indefinite"/>
            </path>
            <path d="M 30,65 Q 40,55 50,65 Q 60,75 70,65">
                <animate attributeName="d" values="M 30,65 Q 40,55 50,65 Q 60,75 70,65;M 30,65 Q 40,75 50,65 Q 60,55 70,65;M 30,65 Q 40,55 50,65 Q 60,75 70,65" dur="3s" repeatCount="indefinite"/>
            </path>
        </g>
        <!-- 纳米机器人 -->
        <g fill="#00ff88" opacity="0.8">
            <circle cx="35" cy="30" r="2">
                <animate attributeName="cy" values="30;70;30" dur="4s" repeatCount="indefinite"/>
            </circle>
            <circle cx="50" cy="25" r="1.5">
                <animate attributeName="cy" values="25;75;25" dur="3.5s" repeatCount="indefinite"/>
            </circle>
            <circle cx="65" cy="35" r="2">
                <animate attributeName="cy" values="35;65;35" dur="4.5s" repeatCount="indefinite"/>
            </circle>
        </g>
        <!-- 修复标识 -->
        <g stroke="#ffffff" stroke-width="3" fill="none" stroke-linecap="round">
            <path d="M 45,50 L 55,50"/>
            <path d="M 50,45 L 50,55"/>
        </g>
        <!-- 能量脉冲 -->
        <circle cx="50" cy="50" r="35" fill="none" stroke="#00ff88" stroke-width="1" opacity="0.4">
            <animate attributeName="r" values="35;45;35" dur="2.5s" repeatCount="indefinite"/>
            <animate attributeName="opacity" values="0.4;0.1;0.4" dur="2.5s" repeatCount="indefinite"/>
        </circle>
    </svg>`,
    
    // 全系统强化
    "all-stats": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="systemGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#ffaa00;stop-opacity:1" />
                <stop offset="33%" style="stop-color:#ff6600;stop-opacity:1" />
                <stop offset="66%" style="stop-color:#ff3300;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#cc0000;stop-opacity:1" />
            </linearGradient>
            <radialGradient id="quantumCore" cx="50%" cy="50%">
                <stop offset="0%" style="stop-color:#ffffff;stop-opacity:1" />
                <stop offset="30%" style="stop-color:#ffaa00;stop-opacity:0.9" />
                <stop offset="70%" style="stop-color:#ff6600;stop-opacity:0.6" />
                <stop offset="100%" style="stop-color:#cc0000;stop-opacity:0.2" />
            </radialGradient>
            <filter id="systemGlow">
                <feGaussianBlur stdDeviation="3" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <!-- 量子八芒星外框 -->
        <g transform="rotate(0 50 50)">
            <polygon points="50,5 58,30 80,22 64,42 90,50 64,58 80,78 58,70 50,95 42,70 20,78 36,58 10,50 36,42 20,22 42,30" 
                     fill="#1a0a0a" stroke="url(#systemGrad)" stroke-width="3" filter="url(#systemGlow)"/>
        </g>
        <!-- 内部能量星 -->
        <g transform="rotate(22.5 50 50)">
            <polygon points="50,15 55,35 75,35 60,45 65,65 50,55 35,65 40,45 25,35 45,35" 
                     fill="url(#quantumCore)" opacity="0.8"/>
        </g>
        <!-- 中心量子核心 -->
        <circle cx="50" cy="50" r="20" fill="#000000" stroke="url(#systemGrad)" stroke-width="2" opacity="0.9"/>
        <circle cx="50" cy="50" r="15" fill="url(#quantumCore)" opacity="0.7"/>
        <!-- 文字标识 -->
        <text x="50" y="46" text-anchor="middle" fill="#ffffff" font-size="10" font-weight="bold">SYS</text>
        <text x="50" y="58" text-anchor="middle" fill="#ffaa00" font-size="12" font-weight="bold">ALL</text>
        <!-- 旋转光环 -->
        <circle cx="50" cy="50" r="30" fill="none" stroke="url(#systemGrad)" stroke-width="2" opacity="0.5" stroke-dasharray="5,5">
            <animateTransform attributeName="transform" type="rotate" 
                            values="0 50 50;360 50 50" dur="3s" repeatCount="indefinite"/>
        </circle>
        <circle cx="50" cy="50" r="35" fill="none" stroke="#ff6600" stroke-width="1" opacity="0.3" stroke-dasharray="3,7">
            <animateTransform attributeName="transform" type="rotate" 
                            values="360 50 50;0 50 50" dur="4s" repeatCount="indefinite"/>
        </circle>
        <!-- 能量脉冲 -->
        <circle cx="50" cy="50" r="40" fill="none" stroke="#ffaa00" stroke-width="1" opacity="0.4">
            <animate attributeName="r" values="40;50;40" dur="2s" repeatCount="indefinite"/>
            <animate attributeName="opacity" values="0.4;0.1;0.4" dur="2s" repeatCount="indefinite"/>
        </circle>
    </svg>`,
    
    // 模块优化校准
    "module-calibration": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="calibGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#00ff00;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#00aa00;stop-opacity:1" />
            </linearGradient>
        </defs>
        <rect x="20" y="30" width="60" height="40" rx="5" fill="#222222" stroke="#444444" stroke-width="2"/>
        <circle cx="35" cy="50" r="8" fill="none" stroke="#00ff00" stroke-width="2"/>
        <circle cx="50" cy="50" r="8" fill="none" stroke="#00ff00" stroke-width="2"/>
        <circle cx="65" cy="50" r="8" fill="none" stroke="#00ff00" stroke-width="2"/>
        <circle cx="35" cy="50" r="3" fill="url(#calibGrad)"/>
        <circle cx="50" cy="50" r="3" fill="url(#calibGrad)"/>
        <circle cx="65" cy="50" r="3" fill="url(#calibGrad)"/>
        <path d="M 30,20 L 50,10 L 70,20" fill="none" stroke="#00ff00" stroke-width="2" stroke-linecap="round"/>
        <path d="M 30,80 L 40,75 M 60,75 L 70,80" stroke="#00ff00" stroke-width="2" stroke-linecap="round"/>
    </svg>`,
    
    // 系统重新编程
    "system-reprogram": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="codeGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#9900ff;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#ff00ff;stop-opacity:1" />
            </linearGradient>
        </defs>
        <rect x="15" y="20" width="70" height="60" rx="5" fill="#1a1a1a" stroke="#333333" stroke-width="2"/>
        <rect x="20" y="25" width="60" height="50" fill="#000000"/>
        <text x="25" y="40" fill="#00ff00" font-family="monospace" font-size="10">&lt;code&gt;</text>
        <rect x="25" y="45" width="30" height="2" fill="url(#codeGrad)"/>
        <rect x="25" y="50" width="40" height="2" fill="#00ff00"/>
        <rect x="25" y="55" width="25" height="2" fill="#00ffff"/>
        <rect x="25" y="60" width="35" height="2" fill="url(#codeGrad)"/>
        <text x="25" y="70" fill="#00ff00" font-family="monospace" font-size="10">&lt;/code&gt;</text>
        <path d="M 70,30 C 75,35 75,35 70,40" fill="none" stroke="#00ff00" stroke-width="2"/>
    </svg>`,
    
    // 标准装备箱
    "standard-supply": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="boxGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#999999;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#666666;stop-opacity:1" />
            </linearGradient>
        </defs>
        <path d="M 20,40 L 50,25 L 80,40 L 80,70 L 50,85 L 20,70 Z" fill="url(#boxGrad)" stroke="#888888" stroke-width="2"/>
        <path d="M 20,40 L 50,55 L 80,40" fill="none" stroke="#888888" stroke-width="2"/>
        <path d="M 50,55 L 50,85" stroke="#888888" stroke-width="2"/>
        <polygon points="45,15 50,5 55,15" fill="#ffcc00" stroke="#ff9900" stroke-width="1"/>
        <path d="M 50,15 L 50,25" stroke="#ff9900" stroke-width="2"/>
    </svg>`,
    
    // 精英装备箱
    "elite-supply": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="eliteGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#ffd700;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#ffaa00;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#ff6600;stop-opacity:1" />
            </linearGradient>
            <filter id="eliteGlow">
                <feGaussianBlur stdDeviation="3" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <path d="M 20,40 L 50,25 L 80,40 L 80,70 L 50,85 L 20,70 Z" fill="#1a1a1a" stroke="url(#eliteGrad)" stroke-width="3" filter="url(#eliteGlow)"/>
        <path d="M 20,40 L 50,55 L 80,40" fill="none" stroke="url(#eliteGrad)" stroke-width="2"/>
        <path d="M 50,55 L 50,85" stroke="url(#eliteGrad)" stroke-width="2"/>
        <polygon points="50,10 55,20 65,20 57,27 60,37 50,30 40,37 43,27 35,20 45,20" 
                 fill="url(#eliteGrad)" stroke="#ff9900" stroke-width="1" filter="url(#eliteGlow)"/>
    </svg>`,
    
    // 标准级宝箱
    "common-chest": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="commonChestGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#cccccc;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#999999;stop-opacity:1" />
            </linearGradient>
        </defs>
        <path d="M 20,40 L 50,25 L 80,40 L 80,70 L 50,85 L 20,70 Z" fill="url(#commonChestGrad)" stroke="#666666" stroke-width="2"/>
        <path d="M 20,40 L 50,55 L 80,40" fill="none" stroke="#666666" stroke-width="2"/>
        <path d="M 50,55 L 50,85" stroke="#666666" stroke-width="2"/>
        <rect x="45" y="50" width="10" height="15" fill="#666666" rx="2"/>
        <circle cx="50" cy="60" r="3" fill="#333333"/>
    </svg>`,
    
    // 改进级宝箱
    "improved-chest": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="improvedChestGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#66ff66;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#00cc00;stop-opacity:1" />
            </linearGradient>
        </defs>
        <path d="M 20,40 L 50,25 L 80,40 L 80,70 L 50,85 L 20,70 Z" fill="#1a1a1a" stroke="url(#improvedChestGrad)" stroke-width="2.5"/>
        <path d="M 20,40 L 50,55 L 80,40" fill="none" stroke="url(#improvedChestGrad)" stroke-width="2"/>
        <path d="M 50,55 L 50,85" stroke="url(#improvedChestGrad)" stroke-width="2"/>
        <rect x="43" y="48" width="14" height="18" fill="url(#improvedChestGrad)" rx="2" opacity="0.8"/>
        <circle cx="50" cy="58" r="4" fill="#00ff00"/>
    </svg>`,
    
    // 军用级宝箱
    "military-chest": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="militaryChestGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#6666ff;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#0033cc;stop-opacity:1" />
            </linearGradient>
            <filter id="militaryGlow">
                <feGaussianBlur stdDeviation="2" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <path d="M 20,40 L 50,25 L 80,40 L 80,70 L 50,85 L 20,70 Z" fill="#0a0a2a" stroke="url(#militaryChestGrad)" stroke-width="3" filter="url(#militaryGlow)"/>
        <path d="M 20,40 L 50,55 L 80,40" fill="none" stroke="url(#militaryChestGrad)" stroke-width="2"/>
        <path d="M 50,55 L 50,85" stroke="url(#militaryChestGrad)" stroke-width="2"/>
        <polygon points="50,45 55,50 50,55 45,50" fill="url(#militaryChestGrad)"/>
        <circle cx="50" cy="50" r="10" fill="none" stroke="#0066ff" stroke-width="1.5" opacity="0.6"/>
    </svg>`,
    
    // 实验级宝箱
    "experimental-chest": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="experimentalChestGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#ff66ff;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#cc00cc;stop-opacity:1" />
            </linearGradient>
            <filter id="experimentalGlow">
                <feGaussianBlur stdDeviation="3" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <path d="M 20,40 L 50,25 L 80,40 L 80,70 L 50,85 L 20,70 Z" fill="#1a0a1a" stroke="url(#experimentalChestGrad)" stroke-width="3" filter="url(#experimentalGlow)"/>
        <path d="M 20,40 L 50,55 L 80,40" fill="none" stroke="url(#experimentalChestGrad)" stroke-width="2"/>
        <path d="M 50,55 L 50,85" stroke="url(#experimentalChestGrad)" stroke-width="2"/>
        <path d="M 40,50 L 50,40 L 60,50 L 50,60 Z" fill="url(#experimentalChestGrad)" opacity="0.8"/>
        <circle cx="50" cy="50" r="15" fill="none" stroke="#ff00ff" stroke-width="1" opacity="0.4"/>
        <circle cx="50" cy="50" r="20" fill="none" stroke="#ff00ff" stroke-width="0.5" opacity="0.3"/>
    </svg>`,
    
    // 传说级宝箱
    "legendary-chest": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="legendaryChestGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#ffaa00;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#ff6600;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#ff3300;stop-opacity:1" />
            </linearGradient>
            <radialGradient id="legendaryCenter">
                <stop offset="0%" style="stop-color:#ffff00;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#ff6600;stop-opacity:0.5" />
            </radialGradient>
            <filter id="legendaryGlow">
                <feGaussianBlur stdDeviation="4" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <path d="M 20,40 L 50,25 L 80,40 L 80,70 L 50,85 L 20,70 Z" fill="#2a1a0a" stroke="url(#legendaryChestGrad)" stroke-width="4" filter="url(#legendaryGlow)"/>
        <path d="M 20,40 L 50,55 L 80,40" fill="none" stroke="url(#legendaryChestGrad)" stroke-width="3"/>
        <path d="M 50,55 L 50,85" stroke="url(#legendaryChestGrad)" stroke-width="3"/>
        <circle cx="50" cy="50" r="12" fill="url(#legendaryCenter)"/>
        <polygon points="50,35 55,45 65,45 57,52 60,62 50,55 40,62 43,52 35,45 45,45" fill="#ffff00" stroke="#ff6600" stroke-width="1"/>
    </svg>`,
    
    // 传家级宝箱
    "heirloom-chest": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="heirloomChestGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#ff0000;stop-opacity:1" />
                <stop offset="33%" style="stop-color:#ff00ff;stop-opacity:1" />
                <stop offset="66%" style="stop-color:#00ffff;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#ffff00;stop-opacity:1" />
            </linearGradient>
            <radialGradient id="heirloomCore">
                <stop offset="0%" style="stop-color:#ffffff;stop-opacity:1" />
                <stop offset="50%" style="stop-color:#ffffff;stop-opacity:0.5" />
                <stop offset="100%" style="stop-color:#ffffff;stop-opacity:0" />
            </radialGradient>
            <filter id="heirloomGlow">
                <feGaussianBlur stdDeviation="5" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <path d="M 20,40 L 50,25 L 80,40 L 80,70 L 50,85 L 20,70 Z" fill="#000000" stroke="url(#heirloomChestGrad)" stroke-width="5" filter="url(#heirloomGlow)"/>
        <path d="M 20,40 L 50,55 L 80,40" fill="none" stroke="url(#heirloomChestGrad)" stroke-width="3"/>
        <path d="M 50,55 L 50,85" stroke="url(#heirloomChestGrad)" stroke-width="3"/>
        <circle cx="50" cy="50" r="15" fill="url(#heirloomCore)"/>
        <path d="M 50,35 L 55,45 L 65,47 L 57,55 L 60,65 L 50,59 L 40,65 L 43,55 L 35,47 L 45,45 Z" 
              fill="none" stroke="url(#heirloomChestGrad)" stroke-width="2" filter="url(#heirloomGlow)"/>
        <circle cx="50" cy="50" r="25" fill="none" stroke="url(#heirloomChestGrad)" stroke-width="1" opacity="0.5" stroke-dasharray="2,2">
            <animateTransform attributeName="transform" type="rotate" from="0 50 50" to="360 50 50" dur="10s" repeatCount="indefinite"/>
        </circle>
    </svg>`,
    
    // 时间重置图标
    "reset-timer": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="timerGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#00ffff;stop-opacity:1" />
                <stop offset="100%" style="stop-color:#0099ff;stop-opacity:1" />
            </linearGradient>
        </defs>
        <circle cx="50" cy="50" r="35" fill="none" stroke="url(#timerGrad)" stroke-width="4"/>
        <circle cx="50" cy="50" r="30" fill="none" stroke="#666666" stroke-width="2"/>
        <path d="M 50,20 L 50,50 L 70,50" fill="none" stroke="#ffffff" stroke-width="3" stroke-linecap="round"/>
        <path d="M 70,30 C 75,35 75,35 70,40" fill="none" stroke="#00ffff" stroke-width="3" stroke-linecap="round"/>
        <path d="M 75,35 L 85,35" stroke="#00ffff" stroke-width="3" stroke-linecap="round"/>
        <circle cx="50" cy="50" r="5" fill="#ffffff"/>
    </svg>`,
    
    // 神秘宝箱图标
    "mystery-chest": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg" class="mystery-chest-svg">
        <defs>
            <linearGradient id="mysteryChestGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#ffaa00;stop-opacity:1">
                    <animate attributeName="stop-color" values="#ffaa00;#ff6600;#ffaa00" dur="2s" repeatCount="indefinite"/>
                </stop>
                <stop offset="100%" style="stop-color:#ff6600;stop-opacity:1">
                    <animate attributeName="stop-color" values="#ff6600;#ffaa00;#ff6600" dur="2s" repeatCount="indefinite"/>
                </stop>
            </linearGradient>
            <filter id="mysteryChestGlow">
                <feGaussianBlur stdDeviation="3" result="coloredBlur"/>
                <feMerge>
                    <feMergeNode in="coloredBlur"/>
                    <feMergeNode in="SourceGraphic"/>
                </feMerge>
            </filter>
        </defs>
        <path d="M 20,40 L 50,25 L 80,40 L 80,70 L 50,85 L 20,70 Z" 
              fill="#2a1a0a" stroke="url(#mysteryChestGrad)" stroke-width="3" filter="url(#mysteryChestGlow)"/>
        <path d="M 20,40 L 50,55 L 80,40" fill="none" stroke="url(#mysteryChestGrad)" stroke-width="2"/>
        <path d="M 50,55 L 50,85" stroke="url(#mysteryChestGrad)" stroke-width="2"/>
        
        <!-- 问号符号 -->
        <text x="50" y="55" text-anchor="middle" fill="url(#mysteryChestGrad)" font-size="24" font-weight="bold" filter="url(#mysteryChestGlow)">?</text>
        
        <!-- 闪光效果 -->
        <g class="sparkle-group">
            <circle cx="30" cy="35" r="2" fill="#ffffff" opacity="0">
                <animate attributeName="opacity" values="0;1;0" dur="3s" begin="0s" repeatCount="indefinite"/>
            </circle>
            <circle cx="70" cy="35" r="2" fill="#ffffff" opacity="0">
                <animate attributeName="opacity" values="0;1;0" dur="3s" begin="0.5s" repeatCount="indefinite"/>
            </circle>
            <circle cx="50" cy="75" r="2" fill="#ffffff" opacity="0">
                <animate attributeName="opacity" values="0;1;0" dur="3s" begin="1s" repeatCount="indefinite"/>
            </circle>
            <circle cx="25" cy="60" r="2" fill="#ffffff" opacity="0">
                <animate attributeName="opacity" values="0;1;0" dur="3s" begin="1.5s" repeatCount="indefinite"/>
            </circle>
            <circle cx="75" cy="60" r="2" fill="#ffffff" opacity="0">
                <animate attributeName="opacity" values="0;1;0" dur="3s" begin="2s" repeatCount="indefinite"/>
            </circle>
        </g>
    </svg>`,
    
    // 已开启宝箱图标
    "opened-chest": `<svg viewBox="0 0 100 100" xmlns="http://www.w3.org/2000/svg">
        <defs>
            <linearGradient id="openedChestGrad" x1="0%" y1="0%" x2="100%" y2="100%">
                <stop offset="0%" style="stop-color:#666666;stop-opacity:1"/>
                <stop offset="100%" style="stop-color:#333333;stop-opacity:1"/>
            </linearGradient>
        </defs>
        <path d="M 20,50 L 50,35 L 80,50 L 80,70 L 50,85 L 20,70 Z" 
              fill="#1a1a1a" stroke="#444444" stroke-width="2"/>
        <path d="M 20,50 L 50,65 L 80,50" fill="none" stroke="#444444" stroke-width="1.5"/>
        <path d="M 50,65 L 50,85" stroke="#444444" stroke-width="1.5"/>
        <path d="M 15,30 L 45,15 L 75,30 L 75,45 L 80,50 L 80,35 L 50,20 L 20,35 L 20,50 L 25,45 Z" 
              fill="#2a2a2a" stroke="#555555" stroke-width="1.5"/>
    </svg>`
};

// 获取商店图标的函数
const getShopIcon = (itemId) => {
    return shopIcons[itemId] || shopIcons["default-icon"];
};

// 创建商店图标的函数（供外部调用）
const createShopIcon = (itemId) => {
    return shopIcons[itemId] || `<span style="font-size: 24px;">${itemId === 'cpu-overclock' ? '⚡' : 
                                                                    itemId === 'weapon-overload' ? '🔥' : 
                                                                    itemId === 'shield-boost' ? '🛡️' : 
                                                                    itemId === 'crit-module' ? '🎯' : 
                                                                    itemId === 'damage-amplifier' ? '💥' : 
                                                                    itemId === 'life-steal' ? '🩸' : 
                                                                    itemId === 'all-stats' ? '⭐' : '❓'}</span>`;
};

// 将函数暴露到全局作用域
window.getShopIcon = getShopIcon;
window.createShopIcon = createShopIcon;